// PURPOSE
// extends SampleOne purpose by showing in more detail
// how to declare arrays
    
// PROGRAM STRUCTURE
// this is a very simple Java program... one class and that one class
// contains the public static void main method
// and it contains no other methods

public class SampleArrays {
 
  public static void main (String[] args) {
    int max = 12;
    
    int[] nums ;  // nums is a variable, and its type is array of int
                  // note this does not allocate any memory for array elements
                  // it just declares to the compiler that we want this variable
                  // and what its type is
                  
    //System.out.println(nums[0]); // this is illegal.. because there are no elements
                                   // no heap memory allocated for array nums
                                    
    double[] dubs = new double[max];  // creating an array of "max" reals..                
                                      // max has value 12 when this happens
                                        
    int numbs[]; // another legal way to declare an array in Java
                 // whether you use this or the other way ( int[] numbs )
                 // is a matter of style
                 // i personally like int[] numbs as it then reads like
                 // the type is array of int ( the int[] ) and the var name
                 // is numbs... and not numbs[] which is not a var name alone
                  
    int[] numss = { 3, 5, 77, -2, 14, 88, 717 , -10 };
      // declaring an array of int, AND allocating memory for the elements... 
      // also giving those elements initial values
    int[] nummsss = new int[]{ 3, 5, 77, -2, 14, 88, 717 , -10 };
      // another way to do the same thing
    
    System.out.println("3rd element is " + numss[2]);
      // note first element would use subscript 0
      // so third element is subscript 2
    
    int[] numm;   // declare a variable with type array of int
                  // but no heap memory is allocated, meaning
                  // the array storage has not been created
                  // all this does is tell the compiler the type of the name "numm"         
    numm = new int[10];   // now creating the storage space for an array of 10 integers
                          // with "new" we allocate an object in the heap, the memory to
                          // hold those 10 integers... 
                          // so now we can try to print their values
    System.out.println(numm[0]); // note that the compiler puts 0 in all the elements for us initially
                                 // 0 when the element type is int
    int foo;
    foo = 8;
    System.out.println(numm[foo]);

    foo = 21;
    //foo = getIntFromKeyboard(); // no idea what foo might have at runtime, so compiler
                                  // cannot object at compile time
    System.out.println(numm[foo]); // erroneous, as there is no element 21; 
                                     // since we allocated 10 elements only subscripts 
                                     // 0 through 9 are valid
    
      
  }

}
