package arrString;

public class SampleOne {

  // PURPOSE
  // this program illustrates creating variable of various types
  // and manipulates them
  // also illustrates simple IO, writing out results
  
  // PROGRAM STRUCTURE
   // this is a very simple Java program... one class and that one class
  // contains the public static void main method
  // and it contains no other methods
  // as such this Java program has NO objects, just the single static main method runs 
  // with the local data declared inside it
  
  public static void main (String[] args) {
    int max = 12;
    double rnum = 103.456;
    
    String sgh = "Go Heels !!";  // a string literal... a constant
    
    String sbd = new String("Beat Duke"); // creating a String using new to make an object
    
    int[] nums = new int[10];         // creating an array of 10 integers
    double[] dubs = new double[max];  // creating an array of "max" reals..                
                                      // max has value 12 when this happens
                                         
    System.out.println(max); 
    max++; 
    System.out.println(max);  
    System.out.println(rnum);
    rnum -= 5.678;
    System.out.println(rnum);  
    System.out.println(rnum * (-21.34));
    System.out.println(rnum);                         
                                      
    // compiler will do some type conversions for you invisibly
    
    rnum = max * rnum;   
        // ^     ^   
        // int * double... appears to mismatch the types
        // but this does compile... 
        // the int value in max is converted to a double 
        // so the mult ends up being double * double                   
    System.out.println(rnum); // so we see a double printed out
    
    // max = max * rnum;   
          // ^     ^   
          // int * double  this appears to also mismatch types
          // in this case the compiler will flag it as error
          // this is because no conversion to int (for the assignment to max)
          // is possible without possibly losing precision
    
    boolean TF;  // declare a variable that contains either the 
                 // logical value "true" or "false"
    TF = true;
    System.out.println(TF);
    TF = false;
    System.out.println(TF);
    TF = !TF;    // NOT, negate whatever is stored in TF
    System.out.println(TF);
    System.out.println(TF || false ); // logical OR
    System.out.println(TF && false ); // logical AND
   
  }

}
