// PURPOSE
// this program shows the nature and behavior of Java String objects

// STRUCTURE
// again, simple, one class, no objects

public class SampleStrings {

  public static void main ( String[] args ) {
    String s1 = "gotarheels";
    String s2 = "gotarheels";
    String s22 = new String("gotarheels");
    System.out.println( s1 == s2 );
    int x = 5;
    int y = 2+3;
    System.out.println( x == y );
    
    // class String has a bunch of methods you can get 
    // a string object execute
    
    s1.toUpperCase();
    System.out.println(s1);
    System.out.println(s1.toUpperCase());
    System.out.println(s1);
    
    System.out.println(s1==s2);
    
    s1 = s1.toUpperCase();
    System.out.println(s1==s2);  // strings are immutable
    
    // you can "change" characters in strings but what you are 
    // really doing is creating a new string out of parts of the 
    // original and new characters
    
    // more String methods
    // see https://www.w3schools.com/java/java_ref_string.asp
    
    System.out.println(s2);
    System.out.println(s2.indexOf("heel"));
    System.out.println(s2.indexOf("t"));
    System.out.println(s2.charAt(2));
    System.out.println(s2.length());
    String s3 = "someText";
    String s4 = "someText";
    System.out.println(s3==s4); // remember... string literals are
                                // stored in the string pool

    System.out.println(s3.equals(s4));
    String s5 = new String("someText");
    System.out.println(s3==s5); // now they are different objects
    System.out.println(s3.equals(s5)); // with the same text context 
  
  }

}
