public class DemoZero {
  // this demo shows programmer written classes with static methods
  // we show that 
  //  1) static methods can be run with no objec, using the class name
  //       AND
  //  2) they can be run by creating an object dynamically as well
  
  public static void main (String[] args) {
     // using class name Moth, in Moth all methods are static
     // this means we can call them all without making a new Moth obj
     System.out.println("Moth: static calls, no object made");
     Moth.cheer();
     System.out.println(Moth.minmult(5,3,12));

     // create an object of class Moth
     // now you can call all methods -- static, and non-static
     // but here, class Moth has only static methods
     // so we see the same results we saw using the class name only
     
     System.out.println("Moth: dynamic (obj) calls on static methods");
     Moth mOb = new Moth();
     mOb.cheer();
     System.out.println(mOb.minmult(12,3,5));
     
   } 
}