// PURPOSE
// this program illustrates creating variable of various types
// and manipulates them
// also illustrates simple IO, writing out results
  
// PROGRAM STRUCTURE
// this is a very simple Java program... one class and that one class
// contains the public static void main method
// and it contains no other methods
// as such this Java program has NO objects, just the single static 
// main runs with the local data declared inside it
  
public class SampleSimple {
 
  public static void main (String[] args) {
    int max = 12;
    double rnum = 103.12345;
    
    String sgh = "Go Heels !!";  // a string literal... a constant
    
    String sbd = new String("Beat Duke"); // creating a String using new to make an object
    
    int[] nums = new int[10];         // creating an array of 10 integers
    double[] dubs = new double[max];  // creating an array of "max" reals..                
                                      // max has value 12 when this happens
                                         
    System.out.println(max); 
    max++; // equivalent of max = max + 1;
    System.out.println(max);  
    System.out.println(rnum);
    rnum -= 5.678;  // rnum = rnum - 5.678 ;
    System.out.println(rnum);  
    System.out.println(rnum * (-21.34));
    System.out.println(rnum);                         
                                      
    // compiler will create code to do some type conversions for you invisibly
    
    rnum = max * rnum;   
        // ^     ^   
        // int * double... appears to mismatch the types
        // but this does compile... 
        // the int value in max is converted to a double 
        // so the mult ends up being double * double                   
    System.out.println(rnum); // so we see a double printed out
    
    max = max * rnum;   
          // ^     ^   
          // int * double  this appears to also mismatch types
          // in this case the compiler will flag it as error
          // this is because no conversion to int (for the assignment to max)
          // is possible without possibly losing precision
    
    boolean val;  // declare a variable that contains either the 
                 // logical value "true" or "false"
    val = true;
    System.out.println(val);
    val = false;
    System.out.println(val);
    val = !val;    // NOT, negate whatever is stored in tf
    System.out.println(val);
    System.out.println(val || false ); // logical OR
    System.out.println(val && false ); // logical AND
   
  }

}
