public class NocapDemo {
  public static void main (String[] args) {
    NoCapso pNO = new NoCapso("Mark", "Jones", 45, 45678.91);
    //              ^^make a new object using EnCapso class as the pattern
    //        ^^ a variable, a reference to the object created in the heap               
    // ^^class name is the type of the variable 
      
      int agee = 45;   
    System.out.println("Non Encapsulated object, Class NoCapso "); 

    System.out.println(pNO.getAge()); // the correct way, call public getter method
                                      // note that we can do this, the right way
                                      // BUT...
    System.out.println(pNO.age);      // we can also do it wrong, reaching into object pNO
                                      // from code outside the object methods
                                      // and using the fields of the objects as if
                                      // they are variables elsewhere
     
    pNO.raiseSalary(21000.00);          // correct way, call a public method
    pNO.salary = pNO.salary + 21000.00; // wrong, reaching into object pNO
                                        // and treating its data fields
                                        // like local variables here

    System.out.println(pNO.getSalary()); // correct way, call public getter
    System.out.println(pNO.salary);      // wrong, reaching into object pNO
                                         // and treating its data fields
                                         // like local variables here
                                         
    pNO.awards = 5; // trying to call method that is private work
                    // but was left public in the class
    System.out.println(pNO.isCommendable(5));
    pNO.addAward();
    System.out.println(pNO.isCommendable(5));

  }
}
